@********************************************************************
@* crt0.s - startup code for arm-elf
@* Target CPU: Arm/T9  Machine: GamePark Holdings GP2X
@********************************************************************

	.GLOBAL _Start

	.EXTERN main	@ user entry point

	.section ".text"
	.align 4
	.code  32

_Start:
	b .RealStart

	@ Address of bss start and end, so that startup code can zero it out
.bss_start:
	.word _bstart
.bss_end:
	.word _bend

	@ Zero out bss
.RealStart:
	ldr r0, .bss_start
	ldr r1, .bss_end
	ldr r2, =0

.BssZeroLoop:
	cmps r0, r1
	beq .BssZeroDone

	strb r2,[r0],#1
	b .BssZeroLoop

.BssZeroDone:
	@ Jump to user entry point
	bl main

atexit:
	ldr r0, =0
	ldr r1, =0x9c000000
	ldr r2, =512

.ReloadUBootLoop:
	ldrb r3,[r1],#1
	strb r3,[r0],#1
	cmp r0, r2
	bne .ReloadUBootLoop

	ldr pc, =0

	.pool

	.END





