/* **************************************************************************
 *    Copyright (C) 2005 by Rob Brown                                       *
 *    rob@cobbleware.com                                                    *
 *                                                                          *
 *    C Implementation: sdk2x_sd_hw                                         *
 *                                                                          *
 *    This program is free software; you can redistribute it and/or modify  *
 *    it under the terms of the GNU General Public License as published by  *
 *    the Free Software Foundation; either version 2 of the License, or     *
 *    (at your option) any later version.                                   *
 *                                                                          *
 *    This program is distributed in the hope that it will be useful,       *
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *    GNU General Public License for more details.                          *
 *                                                                          *
 *    You should have received a copy of the GNU General Public License     *
 *    along with this program; if not, write to the                         *
 *    Free Software Foundation, Inc.,                                       *
 *    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 * **************************************************************************/

#include "mmsp2.h"
#include "sdk2x_priv.h"
#include "stdio.h"

int sdk2x_UartSendString (const int nPort, const char *pString)
{
	if (nPort)
	{
		/* Only allowed to use port 0 at this time :) */
		return -1;
	}

	while (*pString)
	{
		while (!(MSP_TRSTATUS0 & 4));
		MSP_THB0 = *pString;
		pString++;
	}

	return 0;
}

int sdk2x_UartInitialisePort (const int nPort, int nBitRate)
{
	unsigned int apll;
	int i,j;
	int err,newerr;
	int pdiv = 1,pre = 1;

	if (nPort)
	{
		/* Only allowed to use port 0 at this time :) */
		return -1;
	}

	/* Initialise properly by finding clock rate and setting BRG etc */
	apll = sdk2x_GetAPLL() / 16;

	err = 1000000;
	for (i=0;i<64;i++)
	{
		j = ((apll / (i+1)) / nBitRate) - 1;
		newerr = (((apll / (i+1)) / (j + 1)) * 1000) / nBitRate;
		if (j<1)
			newerr = 1000000;

		if (newerr < err)
		{
			pdiv = i;
			pre = j;
			err = newerr;
		}
		sprintf (sdk2x_private_string,"%d %d %d %d %d %d\r\n",i,j,newerr,err,pdiv,pre);
		sdk2x_UartSendString(0,	sdk2x_private_string);
	}

	return 0;
}

