/*
Copyright (C) 1996-1997 Id Software, Inc.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

//
// GP2x video driver by woogal@sector808.org
//
#include "minimal.h"
#include "quakedef.h"
//#include "winquake.h"
#include "d_local.h"
#include <sys/mman.h>
#include <fcntl.h>
#include "SDL.h"

//  int memdev;

//static SDL_Surface *screen=NULL;
//unsigned char *fb[2];
//unsigned short* gp2x_memregs;

#define	BASEWIDTH	320
#define	BASEHEIGHT	240

int min_vid_width;

//vars for mlook
int mouse_down=0, mlook=0;
static int mouse_start_x, mouse_start_y;
float start_yaw, start_pitch;
static int virt_key;
static int autoyaw_left, autoyaw_right;
float yaw_modifier=0;
int		vid_paused=0;

int vid_init=0;

__int64 FPM_TMPVAR_INT64;



viddef_t	vid;				// global video state

//unsigned char	vid_buffer[BASEWIDTH*BASEHEIGHT];
//short		zbuffer[BASEWIDTH*BASEHEIGHT];
//unsigned char	surfcache[256*1024];
unsigned short	d_8to16table[256];
unsigned	d_8to24table[256];

char gpstr[1024];
void GpError(char *text, int hold){
  //  puts(text);
}

/*
================
ClearAllStates
================
*/

/*
================
ClearAllStates
================
*/
void ClearAllStates()
{
	int		i;
	// send an up event for each key, to make sure the server clears them all
	for (i=0 ; i<256 ; i++)
	{
		Key_Event (i, false);
	}
	Key_ClearStates ();
	IN_ClearStates ();
}

/*
================
VID_LockBuffer
================
*/
/*void VID_LockBuffer()
{
}
*/

/*
================
VID_UnlockBuffer
================
*/
/*void VID_UnlockBuffer()
{
}
*/


/*
================
VID_SetPalette
================
*/
void VID_SetPalette (unsigned char *palette)
{
  int i;
  for ( i=0; i<256; ++i )
    {
      gp2x_video_RGB_color8(*palette++,*palette++,*palette++,i);
    }
  gp2x_video_RGB_setpalette();
  /*
	int i; 
	
	gp2x_memregs[0x2958>>1]=0;  // palette table address 0
	for(i=0; i<=255; i++) {
		gp2x_memregs[0x295a>>1]=((palette[i*3+1]>>2)<<8)|palette[i*3+2]>>2;
		gp2x_memregs[0x295a>>1]=palette[i*3]>>2;
        }
  */
	/*

       	SDL_Color colors[256];

    for ( i=0; i<256; ++i )
    {
        colors[i].r = *palette++;
        colors[i].g = *palette++;
        colors[i].b = *palette++;
    }
    SDL_SetColors(screen, colors, 0, 256);
	*/
}

/*
================
VID_ShiftPalette
================
*/
void VID_ShiftPalette (unsigned char *palette)
{
  VID_SetPalette(palette);
}


/*
================
VID_SetMode
================
*/
int VID_SetMode (int modenum, unsigned char *palette)
{
}


/*
================
VID_Init
================
*/
void VID_Init (unsigned char *palette)
{
  //int fbdev[2];

  int chunk;
  byte *cache;
  int cachesize;

  puts("sdl init");
  //    if (SDL_Init(SDL_INIT_VIDEO|SDL_INIT_AUDIO) < 0)
    if (SDL_Init(SDL_INIT_AUDIO) < 0)
        Sys_Error("VID: Couldn't load SDL: %s", SDL_GetError());
    gp2x_init(1000,8,11025,16,1,60,0);
	puts("setvidmode");
	//	screen = SDL_SetVideoMode(320, 240, 8, SDL_SWSURFACE);
	puts("set palette");

	VID_SetPalette(palette);

    puts("initcaches");

    int i,comrowbytes;
    comrowbytes=BASEWIDTH;

    vid.width=BASEWIDTH;
    vid.height=BASEHEIGHT;

    if ((i = COM_CheckParm("-width")) && i + 1 < com_argc)
      vid.width = atoi(com_argv[i + 1]);
    if ((i = COM_CheckParm("-height")) && i + 1 < com_argc)
      vid.height = atoi(com_argv[i + 1]);
    if ((i = COM_CheckParm("-rowbytes")) && i + 1 < com_argc)
      comrowbytes = atoi(com_argv[i + 1]);

    gp2x_video_RGB_setscaling(vid.width,vid.height);

	vid.maxwarpwidth = WARP_WIDTH;
	vid.maxwarpheight = WARP_HEIGHT;
	vid.conwidth = min_vid_width = vid.width;
	vid.conheight = vid.height;
	vid.aspect = 1.0;
	vid.numpages = 4;
	vid.colormap = host_colormap;
	vid.fullbright = 256 - LittleLong (*((int *)vid.colormap + 2048));
	//	vid.buffer = vid.conbuffer = screen->pixels;
	//	vid.rowbytes = vid.conrowbytes = screen->pitch;
	vid.buffer = vid.conbuffer = gp2x_video_RGB[0].screen8;
	//	vid.rowbytes = vid.conrowbytes = BASEWIDTH;
	vid.rowbytes = vid.conrowbytes = comrowbytes;
	vid.direct=0;


	// allocate z buffer and surface cache
	chunk = vid.width * vid.height * sizeof (*d_pzbuffer);
	cachesize = D_SurfaceCacheForRes (vid.width, vid.height);
	chunk += cachesize;
	d_pzbuffer = Hunk_HighAllocName(chunk, "video");
	if (d_pzbuffer == NULL)
	  Sys_Error ("Not enough memory for video mode\n");
	
	// initialize the cache memory 
	cache = (byte *) d_pzbuffer
	  + vid.width * vid.height * sizeof (*d_pzbuffer);
	D_InitCaches (cache, cachesize);
	
	
	//d_pzbuffer = zbuffer;
	//	D_InitCaches (surfcache, sizeof(surfcache));
	
	//Sound initialization
	//S_Init ();
	puts("draw init");
	Draw_Init();

	gp2x_video_logo_enable(1);

	puts("vid init done");
	//	SDL_ShowCursor(0);
	vid_init = 1;
}


/*
================
VID_Shutdown
================
*/
void VID_Shutdown()
{
  SDL_Quit();
  exit(0);
}


/*
================
VID_Update
================
*/
void VID_Update(vrect_t *rects)
{

  gp2x_video_RGB_flip(0);
  vid.buffer = vid.conbuffer = gp2x_video_RGB[0].screen8;
#if 0
    int n, i,x,y,hh,xx,yy;
    Uint8 *screenpixels,*origpixels;

    if (doublesize) {
      if (doublesizestatus.value) {
	hh = 120-24;
      } else {
	hh = 120;
      }   
      SDL_LockSurface(screen);
      screenpixels = (Uint8 *)screen->pixels;
      origpixels=malloc(320*240*sizeof(Uint8));
      memcpy(origpixels,screenpixels,320*240*sizeof(Uint8));
      for (x=80;x<160+80;x++) {
	for (y=60;y<60+hh;y++) {
	  xx=(x-80)*2;
	  yy=(y-60)*2;
	  screenpixels[xx+(yy*320)]=screenpixels[xx+1+(yy*320)]=screenpixels[xx+((yy+1)*320)]=screenpixels[xx+1+((yy+1)*320)]=origpixels[x+(y*320)];
	}
      }
      free(origpixels);
      SDL_UnlockSurface(screen);
    }

    //    SDL_UpdateRect(screen, 0,0,320,240);
    SDL_Flip(screen);
#endif 
#if 0
    int x,y;
	char *pos;
	char *vid1;

	int xx,yy;
	int ww,hh;
	int nextline;

	extern	cvar_t	doublesizestatus;

	if (doublesize) {
	  
	  xx = rects->x;
	  yy = rects->y;
	//	if (doublesize) {
	  ww = rects->width/2;
	  if (doublesizestatus.value) {
	    hh = 120-24;
	  } else {
	    hh = (rects->height/2);
	  }
	  //	} else {
	  //	  ww = rects->width;
	  //	  hh = rects->height;
	  //	}

	nextline = ((240*ww)+1);

	pos  = (char *) gpscreen.ptbuffer + 239 + (xx*240) - yy;
	//	if (doublesize) {
	    vid1 = (char *) vid.buffer + 80 + (36*320)+(24*320);
	    //	} else {
	    //  vid1 = (char *) vid.buffer + xx + (yy*320);
	    //}
	
	    //	if (doublesize) {

	  for (y=0; y<hh; y++) {
	    for (x=0; x<ww; x++ ) {
	      if (doublesize) {
		*(pos+239)=*(pos-1)=*(pos+240)=*(pos) = *(vid1++);
		pos += 480;
	      } else {
		*(pos)=*(vid1++);
		pos += 240;
	      }
	    }
	    //	    if (doublesize) {
	      pos -= nextline*2;
	      //	    } else {
	      //  pos -= nextline;
	      // }
	    vid1+=(320-ww);
	  }

	  if (doublesizestatus.value) {

	    // status bar
	  
	    pos  = (char *) gpscreen.ptbuffer + 239 + (xx*240) - 191;
	    vid1 = (char *) vid.buffer + xx + (191*320);
	    nextline=((240*320)+1);
	    
	    for (y=0;y<48;y++) {
	      for (x=0;x<320;x++) {
		*(pos)=*(vid1++);
		pos+=240;
	      }
	      pos-=nextline;
	    }
	  }

	  //	}

	} else {
	  //	  memcpy(screen->pixels,vid.buffer,sizeof(vid.buffer));
	  
	  //	  XlatVGABuffer ( vid.buffer, (unsigned char *)gpscreen.ptbuffer );
	  
	}
#endif
}	



/*
================
D_BeginDirectRect
================
*/
void D_BeginDirectRect (int x, int y, byte *pbitmap, int width, int height)
{
  /*
    Uint8 *offset;


    if (!screen) return;
    if ( x < 0 ) x = screen->w+x-1;
    offset = (Uint8 *)screen->pixels + y*screen->pitch + x;
    while ( height-- )
    {
        memcpy(offset, pbitmap, width);
        offset += screen->pitch;
        pbitmap += width;
    }
  */
}


/*
================
D_EndDirectRect
================
*/
void D_EndDirectRect (int x, int y, int width, int height)
{
  /*
    if (!screen) return;
    if (x < 0) x = screen->w+x-1;
    SDL_UpdateRect(screen, x, y, width, height);
  */
}





















/*
//==========================================================================
//Dan: Here is where we map keys
byte        scantokey[256] = {
	0,      '\x001', '\x002', '\x003', '\x004', '\x005', '\x006', '\x007', K_BACKSPACE, '\x009',
	'\x00a', '\x00b', '\x00c', K_ENTER, '\x00e', '\x00f', K_SHIFT, '\x011', '\x012', '\x013',
	'\x014', '\x015', '\x016', '\x017', '\x018', '\x019', '\x01a', '\x01b', '\x01c', '\x01d',
	'\x01e', '\x01f', '\x020', '\x021', '\x022', '\x023', '\x024', K_LEFTARROW, K_UPARROW, K_RIGHTARROW,
	K_DOWNARROW, '\x029', '\x02a', '\x02b', '\x02c', '\x02d', '\x02e', '\x02f', ')', '!',
	'@', '#', '$', '%', '^', '&', '*', '(', '\x03a', '\x03b',
	'\x03c', '\x03d', '\x03e', '\x03f', '\x040', '\x041', '\x042', '\x043', '\x044', '\x045',
	'\x046', '\x047', '\x048', '\x049', '\x04a', '\x04b', '\x04c', '\x04d', '\x04e', '\x04f',
	'\x050', '\x051', '\x052', '\x053', '\x054', '\x055', '\x056', '\x057', '\x058', '\x059',
	'\x05a', 0, '\x05c', '\x05d', '\x05e', '\x05f', '\x060', '\x061', '\x062', '\x063',
	'\x064', '\x065', '\x066', '\x067', '\x068', '\x069', '\x06a', '\x06b', '\x06c', '\x06d',
	'\x06e', '\x06f', '\x070', '\x071', '\x072', '\x073', '\x074', '\x075', '\x076', '\x077',
	'\x078', '\x079', '\x07a', '\x07b', '\x07c', '\x07d', '\x07e', '\x07f', '\x080', '\x081',
	'\x082', '\x083', '\x084', '\x085', K_JOY1,  '\x087', '\x088', '\x089', '\x08a', '\x08b',
	'\x08c', '\x08d', '\x08e', '\x08f', '\x090', '\x091', '\x092', '\x093', '\x094', '\x095',
	'\x096', '\x097', '\x098', '\x099', '\x09a', '\x09b', '\x09c', '\x09d', '\x09e', '\x09f',
	'\x0a0', '\x0a1', '\x0a2', '\x0a3', '\x0a4', '\x0a5', '\x0a6', '\x0a7', '\x0a8', '\x0a9',
	'\x0aa', '\x0ab', '\x0ac', '\x0ad', '\x0ae', '\x0af', '\x0b0', '\x0b1', '\x0b2', '\x0b3',
	'\x0b4', '\x0b5', '\x0b6', '\x0b7', '\x0b8', '\x0b9', ':', '+', '<', '_',
	'>', '?', '\x0c0', K_AUX1,  K_AUX2,  K_AUX3,  K_AUX4, K_AUX5, '\x0c6', '\x0c7',
	'\x0c8', '\x0c9', '\x0ca', '\x0cb', '\x0cc', '\x0cd', '\x0ce', '\x0cf', '\x0d0', '\x0d1',
	'\x0d2', '\x0d3', '\x0d4', '\x0d5', '\x0d6', '\x0d7', '\x0d8', '\x0d9', '\x0da', '{',
	'|', '}', '"', '\x0df', '\x0e0', '\x0e1', '\x0e2', '\x0e3', '\x0e4', '\x0e5',
	'\x0e6', '\x0e7', '\x0e8', '\x0e9', '\x0ea', '\x0eb', '\x0ec', '\x0ed', '\x0ee', '\x0ef',
	'\x0f0', '\x0f1', '\x0f2', '\x0f3', '\x0f4', '\x0f5', '\x0f6', '\x0f7', '\x0f8', '\x0f9',
	'\x0fa', '\x0fb', '\x0fc', '\x0fd', '\x0fe', '\x0ff'};

byte        scantolower[256] = {
	0,      '\x001', '\x002', '\x003', '\x004', '\x005', '\x006', '\x007', K_BACKSPACE, '\x009',
	'\x00a', '\x00b', '\x00c', K_ENTER, '\x00e', '\x00f', K_SHIFT, '\x011', '\x012', '\x013',
	'\x014', '\x015', '\x016', '\x017', '\x018', '\x019', '\x01a', '\x01b', '\x01c', '\x01d',
	'\x01e', '\x01f', '\x020', '\x021', '\x022', '\x023', '\x024', K_LEFTARROW, K_UPARROW, K_RIGHTARROW,
	K_DOWNARROW, '\x029', '\x02a', '\x02b', '\x02c', '\x02d', '\x02e', '\x02f', '\x030', '\x031',
	'\x032', '\x033', '\x034', '\x035', '\x036', '\x037', '\x038', '\x039', '\x03a', '\x03b',
	'\x03c', '\x03d', '\x03e', '\x03f', '\x040', 'a', 'b', 'c', 'd', 'e',
	'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o',
	'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y',
	'z', 0, '\x05c', '\x05d', '\x05e', '\x05f', '\x060', '\x061', '\x062', '\x063',
	'\x064', '\x065', '\x066', '\x067', '\x068', '\x069', '\x06a', '\x06b', '\x06c', '\x06d',
	'\x06e', '\x06f', '\x070', '\x071', '\x072', '\x073', '\x074', '\x075', '\x076', '\x077',
	'\x078', '\x079', '\x07a', '\x07b', '\x07c', '\x07d', '\x07e', '\x07f', '\x080', '\x081',
	'\x082', '\x083', '\x084', '\x085', K_JOY1,  '\x087', '\x088', '\x089', '\x08a', '\x08b',
	'\x08c', '\x08d', '\x08e', '\x08f', '\x090', '\x091', '\x092', '\x093', '\x094', '\x095',
	'\x096', '\x097', '\x098', '\x099', '\x09a', '\x09b', '\x09c', '\x09d', '\x09e', '\x09f',
	'\x0a0', '\x0a1', '\x0a2', '\x0a3', '\x0a4', '\x0a5', '\x0a6', '\x0a7', '\x0a8', '\x0a9',
	'\x0aa', '\x0ab', '\x0ac', '\x0ad', '\x0ae', '\x0af', '\x0b0', '\x0b1', '\x0b2', '\x0b3',
	'\x0b4', '\x0b5', '\x0b6', '\x0b7', '\x0b8', '\x0b9', ';', '=', ',', '-',
	'.', '/', '\x0c0', K_AUX1,  K_AUX2,  K_AUX3,  K_AUX4, K_AUX5, '\x0c6', '\x0c7',
	'\x0c8', '\x0c9', '\x0ca', '\x0cb', '\x0cc', '\x0cd', '\x0ce', '\x0cf', '\x0d0', '\x0d1',
	'\x0d2', '\x0d3', '\x0d4', '\x0d5', '\x0d6', '\x0d7', '\x0d8', '\x0d9', '\x0da', '[',
	'\\', ']', '\'', '\x0df', '\x0e0', '\x0e1', '\x0e2', '\x0e3', '\x0e4', '\x0e5',
	'\x0e6', '\x0e7', '\x0e8', '\x0e9', '\x0ea', '\x0eb', '\x0ec', '\x0ed', '\x0ee', '\x0ef',
	'\x0f0', '\x0f1', '\x0f2', '\x0f3', '\x0f4', '\x0f5', '\x0f6', '\x0f7', '\x0f8', '\x0f9',
	'\x0fa', '\x0fb', '\x0fc', '\x0fd', '\x0fe', '\x0ff'};


//=======
//MapKey
//
//Map from windows to quake keynums
//=======

int ignoreNextKey=0;

int MapKey (int key)
{
	if (ignoreNextKey==-key) {
		return ignoreNextKey=0;
	}
	if (ignoreNextKey==key) {
		ignoreNextKey=-key;
		return 0;
	}

	if (key==134) ignoreNextKey=13;

	//Here we take into account screen orientation:
	if (!vid_modenum) return scantokey[key];
	if (vid_modenum==1) {
		int k=scantokey[key];
		switch (k) {
			case K_LEFTARROW:	return K_UPARROW;
			case K_RIGHTARROW:	return K_DOWNARROW;
			case K_UPARROW:		return K_RIGHTARROW;
			case K_DOWNARROW:	return K_LEFTARROW;
			default:			return k;
		}
	}
	if (vid_modenum==2) {
		int k=scantokey[key];
		switch (k) {
			case K_LEFTARROW:	return K_DOWNARROW;
			case K_RIGHTARROW:	return K_UPARROW;
			case K_UPARROW:		return K_LEFTARROW;
			case K_DOWNARROW:	return K_RIGHTARROW;
			default:			return k;
		}
	}

	return scantokey[key];
}

int MapToCap (int key)
{

	if (ignoreNextKey==-key) {
		return ignoreNextKey=0;
	}
	if (ignoreNextKey==key) {
		ignoreNextKey=-key;
		return 0;
	}

	if (key==134) ignoreNextKey=13;

	//Here we take into account screen orientation:
	if (!vid_modenum) return scantokey[key];
	if (vid_modenum==1) {
		int k=scantokey[key];
		switch (k) {
			case K_LEFTARROW:	return K_UPARROW;
			case K_RIGHTARROW:	return K_DOWNARROW;
			case K_UPARROW:		return K_RIGHTARROW;
			case K_DOWNARROW:	return K_LEFTARROW;
			default:			return k;
		}
	}
	if (vid_modenum==2) {
		int k=scantokey[key];
		switch (k) {
			case K_LEFTARROW:	return K_DOWNARROW;
			case K_RIGHTARROW:	return K_UPARROW;
			case K_UPARROW:		return K_LEFTARROW;
			case K_DOWNARROW:	return K_RIGHTARROW;
			default:			return k;
		}
	}

	return scantokey[key];
}

int MapToLower (int key)
{

	if (ignoreNextKey==-key) {
		return ignoreNextKey=0;
	}
	if (ignoreNextKey==key) {
		ignoreNextKey=-key;
		return 0;
	}

	if (key==134) ignoreNextKey=13;

	//Here we take into account screen orientation:
	if (!vid_modenum) return scantolower[key];
	if (vid_modenum==1) {
		int k=scantolower[key];
		switch (k) {
			case K_LEFTARROW:	return K_UPARROW;
			case K_RIGHTARROW:	return K_DOWNARROW;
			case K_UPARROW:		return K_RIGHTARROW;
			case K_DOWNARROW:	return K_LEFTARROW;
			default:			return k;
		}
	}
	if (vid_modenum==2) {
		int k=scantolower[key];
		switch (k) {
			case K_LEFTARROW:	return K_DOWNARROW;
			case K_RIGHTARROW:	return K_UPARROW;
			case K_UPARROW:		return K_LEFTARROW;
			case K_DOWNARROW:	return K_RIGHTARROW;
			default:			return k;
		}
	}

	return scantolower[key];
}

*/
/*
================
VID_HandlePause
================
*/
void VID_HandlePause (qboolean pause)
{
}



/*
===================================================================

MAIN WINDOW

===================================================================
*/



/*
int vid_inactivating=0;
LONG WINAPI MainWndProc (
    HWND    hWnd,
    UINT    uMsg,
    WPARAM  wParam,
    LPARAM  lParam)
{
	LONG			lRet = 0;
	HDC				hdc;
	PAINTSTRUCT		ps;
	static int		recursiveflag;

	switch (uMsg)
	{
		case WM_CREATE:
			//Load the bitmap skins
			//TODO: allow external skins
			ctrlBmp=LoadBitmap(global_hInstance, MAKEINTRESOURCE(IDB_CONTROLS));
			titlebarBmp=LoadBitmap(global_hInstance, MAKEINTRESOURCE(IDB_TITLEBAR));
			{
				//Create font for clock
				LOGFONT lf;
				lf.lfHeight=12;
				lf.lfWidth=0;
				lf.lfEscapement=0;
				lf.lfOrientation=0;
				lf.lfWeight=FW_BOLD;
				lf.lfItalic=FALSE;
				lf.lfUnderline=FALSE;
				lf.lfStrikeOut=FALSE;
				lf.lfCharSet=DEFAULT_CHARSET;
				lf.lfOutPrecision=OUT_DEFAULT_PRECIS;
				lf.lfClipPrecision=CLIP_DEFAULT_PRECIS;
				lf.lfQuality=DEFAULT_QUALITY;
				lf.lfPitchAndFamily=DEFAULT_PITCH;
				_tcscpy(lf.lfFaceName, _T("Tahoma"));

				vid_hClockFont=CreateFontIndirect(&lf);
			}
			break;
		case WM_ACTIVATE:
			if (LOWORD(wParam)==WA_INACTIVE) {
			} else {
				HWND wnd;
				//sndPlaySound(_T("Alarm1.wav"), SND_ASYNC);
				//if (vid_inactivating) return;
				//if ((lParam&&GetParent((HWND)lParam)!=hWnd))
				//	MessageBox(hWnd, _T("Activate"), NULL, MB_OK);
				SHFullScreen(hWnd, SHFS_HIDETASKBAR);
				//The following is to add GigaBar support.  We hide GigaBar if we are full screen
				wnd=FindWindow(_T("GigaBar"), NULL);
				if (wnd) ShowWindow(wnd, SW_HIDE);
				MoveWindow(hWnd, 0, 0, GetSystemMetrics(SM_CXSCREEN), GetSystemMetrics(SM_CYSCREEN), TRUE);

				if (vid_paused) {
					MSG msg;

					ShowWindow(hWnd, SW_SHOW);

					while (PeekMessage (&msg, NULL, 0, 0, PM_NOREMOVE))
					{
						if (!GetMessage (&msg, NULL, 0, 0)) {
							Sys_Quit ();
							return lRet;
						}
      					DispatchMessage (&msg);
					}
					vid_paused=0;
				}
			}

			break;
		case WM_PAINT: {
			hdc = BeginPaint(hWnd, &ps);
			//Here we paint the control skin if in portrait mode
			if ((vid_modenum==0||vid_modenum==NO_MODE)) {
				HBITMAP oBmp;
				HDC bmpDC;

				//TODO: Create  DC for the skin bitmaps once when the bitmaps are loaded.
				bmpDC=CreateCompatibleDC(hdc);
				oBmp=SelectObject(bmpDC, titlebarBmp);
				//Blit the titlebar bitmap
				BitBlt(hdc, 0, 0, 240, 24, bmpDC, 0, 0, SRCCOPY);
				//Update the clock
				vid_clockrect.left=181;
				vid_clockrect.top=3;
				vid_clockrect.right=211;
				vid_clockrect.bottom=21;
				PaintCapTime(hdc, &vid_clockrect);

				SelectObject(bmpDC, ctrlBmp);
				//Blit the control bitmap
				BitBlt(hdc, 0, CONTROL_TOP, 240, 320-CONTROL_TOP, bmpDC, 0, 0, SRCCOPY);

				SelectObject(bmpDC, oBmp);
				DeleteDC(bmpDC);

				//Tell Quake to force an update of the game portion of the screen
				if (!in_mode_set && host_initialized)
					SCR_UpdateWholeScreen ();

			}
			EndPaint(hWnd, &ps);
			break;
		}
		case WM_CHAR:
			if (!in_mode_set&&!vid_paused)
					if (MapKey(wParam))
						Key_Event (MapKey(wParam), true);
			break;
		case WM_DEADCHAR:
			if (!in_mode_set&&!vid_paused)
					if (MapKey(wParam))
						Key_Event (MapKey(wParam), false);
			break;
		case WM_KEYDOWN: {
			if (!in_mode_set&&!vid_paused) {
				if (GetKeyState(VK_SHIFT)&0x8000||GetKeyState(VK_CAPITAL)&0x0001) {
					if (MapToCap(wParam)) Key_Event (MapToCap(wParam), true);
				} else
					if (MapToLower(wParam)) Key_Event (MapToLower(wParam), true);
			}
			break;
		}
		case WM_KEYUP:
			if (!in_mode_set&&!vid_paused) {
				if (GetKeyState(VK_SHIFT)&0x8000||GetKeyState(VK_CAPITAL)&0x0001) {
					if (MapToCap(wParam)) Key_Event (MapToCap(wParam), false);
				} else
					if (MapToLower(wParam)) Key_Event (MapToLower(wParam), false);
			}
			break;
		case WM_LBUTTONDOWN:
			if (!vid_paused)
				Win_MouseButton(wParam, lParam, true);
			break;
		case WM_LBUTTONUP:
			if (!vid_paused)
				Win_MouseButton(wParam, lParam, false);
			break;
		case WM_MOUSEMOVE:
			if (!vid_paused)
				Win_MouseMove(wParam, lParam);
			break;
   	    case WM_CLOSE:
		//Dan East: TODO: Looks like ID Software forgot to save any settings when a quit
		//is requested via Windows.  Quitting by a windows command should result in the same
		//code being called as quitting via the Quake Console command "Quit".
			if (!in_mode_set)
			{
				if (MessageBox (hWnd, _T("Are you sure you want to quit?"), _T("Confirm Exit"),
							MB_YESNO | MB_SETFOREGROUND | MB_ICONQUESTION) == IDYES)
				{
					vid_paused=0;
					Sys_Quit ();
				}
			}
			break;
		default:
            // pass all unhandled messages to DefWindowProc
            lRet = DefWindowProc (hWnd, uMsg, wParam, lParam);
	        break;
    }

    // return 0 if handled message, 1 if not
    return lRet;
}


extern void M_Menu_Options_f (void);
extern void M_Print (int cx, int cy, char *str);
extern void M_PrintWhite (int cx, int cy, char *str);
extern void M_DrawCharacter (int cx, int line, int num);
extern void M_DrawTransPic (int x, int y, qpic_t *pic);
extern void M_DrawPic (int x, int y, qpic_t *pic);

static int	vid_line, vid_wmodes;

typedef struct
{
	int		modenum;
	char	*desc;
	int		iscur;
	int		ismode13;
	int		width;
} modedesc_t;

#define MAX_COLUMN_SIZE		5
#define MODE_AREA_HEIGHT	(MAX_COLUMN_SIZE + 6)
#define MAX_MODEDESCS		(MAX_COLUMN_SIZE*3)

static modedesc_t	modedescs[MAX_MODEDESCS];


//================
//VID_MenuDraw
//================

void VID_MenuDraw (void)
{
	qpic_t		*p;
	char		*ptr;
	int			lnummodes, i, j, k, column, row, dup, dupmode;
	vmode_t		*pv;
	modedesc_t	tmodedesc;

	p = Draw_CachePic ("gfx/vidmodes.lmp");
	M_DrawPic ( (min_vid_width-p->width)/2, 4, p);

	for (i=0 ; i<3 ; i++)
	{
		ptr = VID_GetModeDescriptionMemCheck (i);
		modedescs[i].modenum = modelist[i].modenum;
		modedescs[i].desc = ptr;
		modedescs[i].ismode13 = 0;
		modedescs[i].iscur = 0;

		if (vid_modenum == i)
			modedescs[i].iscur = 1;
	}

	vid_wmodes = 3;
	lnummodes = VID_NumModes ();

	for (i=3 ; i<lnummodes ; i++)
	{
		ptr = VID_GetModeDescriptionMemCheck (i);
		pv = VID_GetModePtr (i);

	// we only have room for 15 fullscreen modes, so don't allow
	// 360-wide modes, because if there are 5 320-wide modes and
	// 5 360-wide modes, we'll run out of space
		if (ptr && ((pv->width != 360) || COM_CheckParm("-allow360")))
		{
			dup = 0;

			for (j=3 ; j<vid_wmodes ; j++)
			{
				if (!strcmp (modedescs[j].desc, ptr))
				{
					dup = 1;
					dupmode = j;
					break;
				}
			}

			if (dup || (vid_wmodes < MAX_MODEDESCS))
			{
				if (!dup || !modedescs[dupmode].ismode13 || COM_CheckParm("-noforcevga"))
				{
					if (dup)
					{
						k = dupmode;
					}
					else
					{
						k = vid_wmodes;
					}

					modedescs[k].modenum = i;
					modedescs[k].desc = ptr;
					modedescs[k].ismode13 = pv->mode13;
					modedescs[k].iscur = 0;
					modedescs[k].width = pv->width;

					if (i == vid_modenum)
						modedescs[k].iscur = 1;

					if (!dup)
						vid_wmodes++;
				}
			}
		}
	}

// sort the modes on width (to handle picking up oddball dibonly modes
// after all the others)
	for (i=3 ; i<(vid_wmodes-1) ; i++)
	{
		for (j=(i+1) ; j<vid_wmodes ; j++)
		{
			if (modedescs[i].width > modedescs[j].width)
			{
				tmodedesc = modedescs[i];
				modedescs[i] = modedescs[j];
				modedescs[j] = tmodedesc;
			}
		}
	}


	M_Print ((vid.width-15*8)/2 , 36, "Pocket PC Modes");

	column = 16;
	row = 36+2*8;

	for (i=0 ; i<3; i++)
	{
		if (modedescs[i].iscur)
			M_PrintWhite (column, row, modedescs[i].desc);
		else
			M_Print (column, row, modedescs[i].desc);

		//column += 13*8;
		row+=16;
	}
	{
		M_Print ((vid.width-23*8)/2 , 36 + MODE_AREA_HEIGHT * 8 + 8,
				"Press Enter to set mode");
		ptr = VID_GetModeDescription2 (vid_modenum);
		M_Print ((vid.width-11*8)/2 , 36 + MODE_AREA_HEIGHT * 8 + 24,
				"Esc to exit");


		column-=10;
		row -= (3-vid_line)*16;


		M_DrawCharacter (column, row, 12+((int)(realtime*4)&1));
	}
}



//================
//VID_MenuKey
//================

void VID_MenuKey (int key)
{
	if (vid_testingmode)
		return;

	switch (key)
	{
	case K_ESCAPE:
		S_LocalSound ("misc/menu1.wav");
		M_Menu_Options_f ();
		break;
	case K_LEFTARROW:
	case K_UPARROW:
		S_LocalSound ("misc/menu1.wav");
		vid_line--;
		if (vid_line < 0) vid_line=vid_wmodes-1;
		break;
	case K_RIGHTARROW:
	case K_DOWNARROW:
		S_LocalSound ("misc/menu1.wav");
		vid_line++;
		if (vid_line>=vid_wmodes) vid_line=0;
		break;

	case K_ENTER:
		S_LocalSound ("misc/menu1.wav");
		VID_SetMode (modedescs[vid_line].modenum, NULL);
		//VID_SetMode (modedescs[vid_line].modenum, (unsigned char *)vid_curpal);
		break;

	case 'T':
	case 't':
		S_LocalSound ("misc/menu1.wav");
	// have to set this before setting the mode because WM_PAINT
	// happens during the mode set and does a VID_Update, which
	// checks vid_testingmode
		//if (!VID_SetMode (modedescs[vid_line].modenum, (unsigned char *)vid_curpal))
		VID_SetMode (modedescs[vid_line].modenum, NULL);
		break;
	default:
		break;
	}
}
*/
void DeinitConProc (void);

